package com.huigou.topsun.sap.nonProdApply.controller;


import com.huigou.cache.DictUtil;
import com.huigou.context.Operator;
import com.huigou.context.OrgUnit;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyApplication;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyDeptApplication;
import com.huigou.topsun.sap.nonProdApply.domain.NonProdApplyBaseInfo;
import com.huigou.topsun.sap.nonProdApply.domain.SapNonProdApplyDept;
import com.huigou.topsun.sap.nonProdApply.domain.query.NonProdApplyBaseInfoQueryRequest;
import com.huigou.topsun.sap.suppliers.application.SuppliersDataApplication;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.bmp.common.BizBillStatus;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import com.huigou.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import java.text.SimpleDateFormat;
import java.util.*;

@Controller
@ControllerMapping("/sapNonProdApply")
public class NonProdApplyController extends CommonController {

    protected String getPagePath() {
        return "/biz/topsun/sap/nonProdApply/";
    }
    @Autowired
    NonProdApplyApplication nonProdApplyApplication;
    @Autowired
    NonProdApplyDeptApplication nonProdApplyDeptApplication;

    public String forwardNonProdApplyList(){
        return forward("nonProdApplyList");
    }

    public String forwardNonProdApplyDetail(){
        this.putAttribute("processDefinitionKey", NonProdApplyApplication.PROCESS_DEFINITION_KEY);
        this.putAttribute("procUnitId", "Apply");//定义流程环节的id
        this.putAttribute("applyType","0");
        SDO sdo = this.getSDO();
        String bizId=sdo.getString("bizId");
        String extended=sdo.getString("extend");
        NonProdApplyBaseInfo nonProdApplyBaseInfo = new NonProdApplyBaseInfo();
        nonProdApplyBaseInfo.setMaintenanceType("new");
        nonProdApplyBaseInfo.setApplyType("0");
        if (StringUtil.isNotBlank(extended)){ //扩展流程
            nonProdApplyBaseInfo = nonProdApplyApplication.loadNonProdApplyBaseInfoById(bizId);
            this.putAttribute("processDefinitionKey", NonProdApplyApplication.PROCESS_DEFINITION_KEY_EXD);
            this.putAttribute("applyType", "2");
            nonProdApplyBaseInfo.setMaintenanceType("extend");
            nonProdApplyBaseInfo.setBillCode("");
            nonProdApplyBaseInfo.setId("");
            // suppliersInfo.setSId(bizId);
            Map<String, Object> map = new HashMap();
            map.put("bizId", "");
            sdo.setProperties(map);
            nonProdApplyBaseInfo.setFullId("");
            nonProdApplyBaseInfo.setSourceId(bizId);
            Map <String,String>dictMapUsage=DictUtil.getDictionary("serviceusage");
            List <Map<String,String>> list=new ArrayList<>();
             //for (Map maps:mapUsage){
             //查询扩展前所有的 业务部门
            String usedBusiness=nonProdApplyApplication.getChangeBusinessUsage(bizId,"扩展");
            String []usages=usedBusiness.split(",");//nonProdApplyBaseInfo.getBusinessUsage().split(",");
            Map <String, String>mapTmp=new HashMap();
            Map <String, String>unMapTmp=new HashMap();
            for (Map.Entry<String, String> entry : dictMapUsage.entrySet()) {
                String key = entry.getKey().toUpperCase();
               for (String usage:usages){
                  if (key.equals(usage)){
                      mapTmp.put(key, entry.getValue());
                      break;
                  }
               }
            }
            for (Map.Entry<String, String> entry : dictMapUsage.entrySet()) {
                 String key = entry.getKey().toUpperCase();
                 boolean isexists=false;
                for (Map.Entry<String, String> entry2 : mapTmp.entrySet()) {
                     if (entry2.getKey().toUpperCase().equals(key)){
                        isexists=true;
                        break;
                    }
                }
                if (!isexists) {
                    unMapTmp.put(key, entry.getValue());
                }
            }

           this.putAttribute("businessUsageSeledList",mapTmp);
           this.putAttribute("businessUsageUnSeledList",unMapTmp);
           // nonProdApplyBaseInfo.setBusinessUsageSeled(nonProdApplyBaseInfo.getBusinessUsage());
            nonProdApplyBaseInfo.setBusinessUsageSeled(usedBusiness);
            nonProdApplyBaseInfo.setApplyType("2");
            this.putAttribute("bizId", "");
            this.putAttribute("sourceId", bizId);
            this.putAttribute("id", "");
        } else {  //变更
            if (StringUtil.isNotBlank(bizId)) {
                nonProdApplyBaseInfo = nonProdApplyApplication.loadNonProdApplyBaseInfoById(bizId);

                this.putAttribute("processDefinitionKey", NonProdApplyApplication.PROCESS_DEFINITION_KEY_MOD);
                this.putAttribute("applyType", "1");
                nonProdApplyBaseInfo.setMaintenanceType("modify");
                nonProdApplyBaseInfo.setBillCode("");
                nonProdApplyBaseInfo.setId("");
                nonProdApplyBaseInfo.setApplyType("1");
                // suppliersInfo.setSId(bizId);
                //获取变更前的业务状态
                String usedBusiness=nonProdApplyApplication.getChangeBusinessUsage(bizId,"变更");
                Map<String, Object> map = new HashMap();
                map.put("bizId", "");
                sdo.setProperties(map);
                nonProdApplyBaseInfo.setFullId("");
                nonProdApplyBaseInfo.setSourceId(bizId);
                this.putAttribute("bizId", "");
                this.putAttribute("sourceId", bizId);
                this.putAttribute("id", "");
            }
        }

        nonProdApplyBaseInfo.setStatusId(BizBillStatus.APPLYING.getId());
        Operator operator = getOperator();//获取当前操作员的详情信息
        nonProdApplyBaseInfo.setDefaultValues(new OrgUnit(operator.getFullId(), operator.getFullName()));
        return forward("nonProdApplyDetail",nonProdApplyBaseInfo);
    }



    public String slicedNonProdApplyList(){
        SDO sdo = this.getSDO();
        NonProdApplyBaseInfoQueryRequest queryRequest = sdo.toQueryRequest(NonProdApplyBaseInfoQueryRequest.class);
        Map<String, Object> map = nonProdApplyApplication.slicedNonProdApplyBaseInfoQuery(queryRequest);
        return toResult(map);
    }


    /**
     * 工作流审核跳转页面
     * @return
     */
    public String showNonProdApply() {
        SDO sdo = this.getSDO();
        String id = sdo.getBizId();
        String isDetailPage = sdo.getString("isDetailPage");
        if("true".equals(isDetailPage)) this.putAttribute("isDetailPage","true");
        NonProdApplyBaseInfo nonProdApplyBaseInfo = nonProdApplyApplication.loadNonProdApplyBaseInfoById(id);
        nonProdApplyBaseInfo.setApplyType("0");
        if (nonProdApplyBaseInfo.getMaintenanceType().equals("modify")){
            nonProdApplyBaseInfo.setApplyType("1");
            this.putAttribute("applyType", "1");
        }  if (nonProdApplyBaseInfo.getMaintenanceType().equals("extend")){
            nonProdApplyBaseInfo.setApplyType("2");
            this.putAttribute("applyType", "2");
            Map <String,String>dictMapUsage=DictUtil.getDictionary("serviceusage");
            NonProdApplyBaseInfo sourceNonProdApplyBaseInfo=nonProdApplyApplication.loadNonProdApplyBaseInfoById(nonProdApplyBaseInfo.getSourceId());
           // String []usages=sourceNonProdApplyBaseInfo.getBusinessUsage().split(",");

            //String []exdusages=nonProdApplyBaseInfo.getBusinessUsage().split(",");
            //查询扩展前所有的 业务部门
            SapNonProdApplyDept nonProdApplyDept = nonProdApplyDeptApplication.getNonProdApplyDeptByBaseInfoId(id);
            NonProdApplyBaseInfoQueryRequest queryRequest=new NonProdApplyBaseInfoQueryRequest();
            queryRequest.setMatnr(nonProdApplyDept.getMatnr());
            Map exmap=nonProdApplyApplication.slicedNonApplyBaseInfoByMatnr(queryRequest);

            List <Map <String,Object>>extendedList=(List)exmap.get("Rows");
            String usedBusiness="";
            for (Map <String,Object>mapExd:extendedList) {
                usedBusiness+=mapExd.get("businessUsage").toString()+",";
            }
            if (usedBusiness.length()>1){
                usedBusiness=usedBusiness.substring(0,usedBusiness.length()-1);
            }
            usedBusiness=usedBusiness.replaceAll(nonProdApplyBaseInfo.getBusinessUsage(),"");//去掉本次的
            nonProdApplyBaseInfo.setBusinessUsageSeled(usedBusiness);
            String []usages=usedBusiness.split(",");

            Map <String, String>mapTmp=new HashMap();
            Map <String, String>unMapTmp=new HashMap();
            for (Map.Entry<String, String> entry: dictMapUsage.entrySet()) {
                String key = entry.getKey().toUpperCase();
                for (String usage:usages){
                    if (key.equals(usage)){
                        mapTmp.put(key, entry.getValue());
                        break;
                    }
                }
            }
            for (Map.Entry<String, String> entry : dictMapUsage.entrySet()) {
                String key = entry.getKey().toUpperCase();
                boolean isexists=false;
                for (Map.Entry<String, String> entry2 : mapTmp.entrySet()) {
                    if (entry2.getKey().toUpperCase().equals(key)){
                        isexists=true;
                        break;
                    }
                }
                if (!isexists) {
                    unMapTmp.put(key, entry.getValue());
                }
            }

            this.putAttribute("businessUsageSeledList",mapTmp);
            this.putAttribute("businessUsageUnSeledList",unMapTmp);
        }
        return forward("nonProdApplyDetail", nonProdApplyBaseInfo);
    }

    public String deleteNonProdApply(){
        SDO sdo = this.getSDO();
        List<String> ids = sdo.getIds();
        nonProdApplyApplication.deleteNonProdApplyBaseInfoByIds(ids);
        return success();
    }

    public String  publishDataToSap(){
        SDO sdo = this.getSDO();

       // System.out.println("id============"+sdo.getString("id"));
        nonProdApplyApplication.publishDataToSap(sdo.getString("id"));
        return success();
    }
}


